#include "StdAfx.h"
#include "RndWnd.h"
#include "BWLDArea.h"

//    CBWLDArea
CBrkWinArea* CreateCBWLDArea(POINT AreaPos, SIZE AreaSize, CBrokenWinCore* pBrokenWin)
{
	return new CBWLDArea(CBWLDArea::AREA_ID,AreaPos,AreaSize,pBrokenWin);
}

// 
CBWLDArea::CBWLDArea(WORD AreaID, POINT AreaPos, SIZE AreaSize, CBrokenWinCore* pBrokenWin)
: CBrkWinArea(AreaID,AreaPos,AreaSize,pBrokenWin)
{
	m_pPath = NULL;
}

// 
CBWLDArea::~CBWLDArea(void)
{
}

//  
void CBWLDArea::InitEvent()
{
	//   
	Rect AreaRect(0, -m_Size.cy, 2 * m_Size.cx, 2 * m_Size.cy);

	//   
	m_pPath = new GraphicsPath();
	m_pPath->AddArc(AreaRect, 90, 90);
	m_pPath->AddLine(0, 0, m_Size.cx - 1, 0);
	m_pPath->CloseFigure();
}

//  
void CBWLDArea::DeInitEvent()
{
	//  
	if (m_pPath != NULL)
	{
		delete m_pPath;
		m_pPath = NULL;
	}
}

//  
void CBWLDArea::DrawEvent(HDC hDC)
{
	Graphics graph(hDC);

	//   
	CBWMainWnd* pMainWnd = (CBWMainWnd*)m_pBrokenWin;
	_ASSERT(pMainWnd != NULL);

	//     
	AREA_STATE AreaState = pMainWnd->GetAreaState();

	SolidBrush LeftPathBrush(Color(200, 0, 200));
	if (AreaState == LEFT_DOWN)
		LeftPathBrush.SetColor(Color(255, 0, 255));
	graph.FillPath(&LeftPathBrush, m_pPath);
}

//    
void CBWLDArea::MouseInArea(POINT point)
{
	//   
	CBWMainWnd* pMainWnd = (CBWMainWnd*)m_pBrokenWin;
	_ASSERT(pMainWnd != NULL);

	pMainWnd->SetAreaState(LEFT_DOWN);
	pMainWnd->ReDrawBW();
}

//    
void CBWLDArea::MouseOutArea()
{
	//   
	CBWMainWnd* pMainWnd = (CBWMainWnd*)m_pBrokenWin;
	_ASSERT(pMainWnd != NULL);

	pMainWnd->SetAreaState(NONE);
	pMainWnd->ReDrawBW();
}
