#include "StdAfx.h"
#include "RndWnd.h"
#include "BWLUArea.h"

//    CBWLUArea
CBrkWinArea* CreateCBWLUArea(POINT AreaPos, SIZE AreaSize, CBrokenWinCore* pBrokenWin)
{
	return new CBWLUArea(CBWLUArea::AREA_ID,AreaPos,AreaSize,pBrokenWin);
}

// 
CBWLUArea::CBWLUArea(WORD AreaID, POINT AreaPos, SIZE AreaSize, CBrokenWinCore* pBrokenWin)
: CBrkWinArea(AreaID,AreaPos,AreaSize,pBrokenWin)
{
	m_pPath = NULL;
}

// 
CBWLUArea::~CBWLUArea(void)
{
}

//  
void CBWLUArea::InitEvent()
{
	//   
	Rect AreaRect(0, 0, 2 * m_Size.cx, 2 * m_Size.cy);

	//   
	m_pPath = new GraphicsPath();
	m_pPath->AddArc(AreaRect, 180, 90);
	m_pPath->AddLine(m_Size.cx-1, 0, m_Size.cx-1, m_Size.cy-1);
	m_pPath->CloseFigure();
}

//  
void CBWLUArea::DeInitEvent()
{
	//  
	if (m_pPath != NULL)
	{
		delete m_pPath;
		m_pPath = NULL;
	}
}

//  
void CBWLUArea::DrawEvent(HDC hDC)
{
	Graphics graph(hDC);

	//   
	CBWMainWnd* pMainWnd = (CBWMainWnd*)m_pBrokenWin;
	_ASSERT(pMainWnd != NULL);

	//     
	AREA_STATE AreaState = pMainWnd->GetAreaState();

	SolidBrush LeftPathBrush(Color(0, 200, 0));
	if (AreaState == LEFT_UP)
		LeftPathBrush.SetColor(Color(0, 255, 0));
	graph.FillPath(&LeftPathBrush, m_pPath);
}

//    
void CBWLUArea::MouseInArea(POINT point)
{
	//   
	CBWMainWnd* pMainWnd = (CBWMainWnd*)m_pBrokenWin;
	_ASSERT(pMainWnd != NULL);

	pMainWnd->SetAreaState(LEFT_UP);
	pMainWnd->ReDrawBW();
}

//    
void CBWLUArea::MouseOutArea()
{
	//   
	CBWMainWnd* pMainWnd = (CBWMainWnd*)m_pBrokenWin;
	_ASSERT(pMainWnd != NULL);

	pMainWnd->SetAreaState(NONE);
	pMainWnd->ReDrawBW();
}
