// --------------------------------------------------------------
//     RndWnd
//
//  
// --------------------------------------------------------------
#include "StdAfx.h"
#include "RndWnd.h"
#include "BWMainWnd.h"
#include "BWRDArea.h"
#include "BWLDArea.h"
#include "BWRUArea.h"
#include "BWLUArea.h"

//     " ".
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

CBWMainWnd::CBWMainWnd(void)
{
	m_AreaState = NONE;
	m_hMainMenu = NULL;
}

CBWMainWnd::~CBWMainWnd(void)
{
}

//  
BEGIN_BWAREA_MAP(CBWMainWnd)
	BWAREA(IDW_LU_AREA,CreateCBWLUArea)
	BWAREA(IDW_RU_AREA,CreateCBWRUArea)
	BWAREA(IDW_LD_AREA,CreateCBWLDArea)
	BWAREA(IDW_RD_AREA,CreateCBWRDArea)
END_BWAREA_MAP()

//   
int CBWMainWnd::CreateEvent(HWND hBrkWin, LPCREATESTRUCT lpCS)
{
	//   
	m_hMainMenu = ::LoadMenu(g_hInstance, MAKEINTRESOURCE(IDC_RNDWND));

	return 0;
}

//   
void CBWMainWnd::DestroyEvent()
{
	//   
	PostQuitMessage(0); 
}

//  
void CBWMainWnd::CloseEvent()
{
	if (::MessageBox(m_hWnd, _T("      ?"), g_szTitle, MB_OK | MB_YESNO | MB_ICONQUESTION) == IDYES)
	{
		//   
		::DestroyWindow(m_hWnd);
	}
}

//   
void CBWMainWnd::DrawEvent(HDC hDC)
{
	Graphics graph(hDC);

	//    
	RECT ClRect;
	::GetClientRect(m_hWnd, &ClRect);

	//  
	Color BkColor;
	BkColor.SetFromCOLORREF(TRANSPARENT_COLOR);
	SolidBrush brush(BkColor);
	graph.FillRectangle(&brush, 0, 0, ClRect.right, ClRect.bottom);
}

//   
void CBWMainWnd::ContextMenuEvent(UINT xPos, UINT yPos)
{
	//  
	::TrackPopupMenuEx(::GetSubMenu(m_hMainMenu, 0), TPM_LEFTALIGN | TPM_TOPALIGN, xPos, yPos, m_hWnd, NULL);
}

//  
void CBWMainWnd::CommandEvent(int id, HWND hwndCtl, UINT codeNotify)
{
	switch (id)
	{
	case IDM_ABOUT:
		DialogBox(g_hInstance, MAKEINTRESOURCE(IDD_ABOUTBOX), m_hWnd, About);
		break;
	case IDM_EXIT:
		//   
		::DestroyWindow(m_hWnd);
		break;
	}
}

//     
AREA_STATE CBWMainWnd::GetAreaState()
{
	return m_AreaState;
}

//     
void CBWMainWnd::SetAreaState(AREA_STATE State)
{
	m_AreaState = State;
}
