#include "StdAfx.h"
#include "RndWnd.h"
#include "BWRDArea.h"

//    CBWRDArea
CBrkWinArea* CreateCBWRDArea(POINT AreaPos, SIZE AreaSize, CBrokenWinCore* pBrokenWin)
{
	return new CBWRDArea(CBWRDArea::AREA_ID,AreaPos,AreaSize,pBrokenWin);
}

// 
CBWRDArea::CBWRDArea(WORD AreaID, POINT AreaPos, SIZE AreaSize, CBrokenWinCore* pBrokenWin)
: CBrkWinArea(AreaID,AreaPos,AreaSize,pBrokenWin)
{
	m_pPath = NULL;
}

// 
CBWRDArea::~CBWRDArea(void)
{
}

//  
void CBWRDArea::InitEvent()
{
	//   
	Rect AreaRect(-m_Size.cx, -m_Size.cy, 2 * m_Size.cx, 2 * m_Size.cy);

	//   
	m_pPath = new GraphicsPath();
	m_pPath->AddArc(AreaRect, 0, 90);
	m_pPath->AddLine(0, m_Size.cy - 1, 0, 0);
	m_pPath->CloseFigure();
}

//  
void CBWRDArea::DeInitEvent()
{
	//  
	if (m_pPath != NULL)
	{
		delete m_pPath;
		m_pPath = NULL;
	}
}

//  
void CBWRDArea::DrawEvent(HDC hDC)
{
	Graphics graph(hDC);

	//   
	CBWMainWnd* pMainWnd = (CBWMainWnd*)m_pBrokenWin;
	_ASSERT(pMainWnd != NULL);

	//     
	AREA_STATE AreaState = pMainWnd->GetAreaState();

	SolidBrush LeftPathBrush(Color(200, 0, 0));
	if (AreaState == RIGHT_DOWN)
		LeftPathBrush.SetColor(Color(255, 0, 0));
	graph.FillPath(&LeftPathBrush, m_pPath);
}

//    
void CBWRDArea::MouseInArea(POINT point)
{
	//   
	CBWMainWnd* pMainWnd = (CBWMainWnd*)m_pBrokenWin;
	_ASSERT(pMainWnd != NULL);

	pMainWnd->SetAreaState(RIGHT_DOWN);
	pMainWnd->ReDrawBW();
}

//    
void CBWRDArea::MouseOutArea()
{
	//   
	CBWMainWnd* pMainWnd = (CBWMainWnd*)m_pBrokenWin;
	_ASSERT(pMainWnd != NULL);

	pMainWnd->SetAreaState(NONE);
	pMainWnd->ReDrawBW();
}
