#include "StdAfx.h"
#include "RndWnd.h"
#include "BWRUArea.h"

//    CBWRUArea
CBrkWinArea* CreateCBWRUArea(POINT AreaPos, SIZE AreaSize, CBrokenWinCore* pBrokenWin)
{
	return new CBWRUArea(CBWRUArea::AREA_ID,AreaPos,AreaSize,pBrokenWin);
}

// 
CBWRUArea::CBWRUArea(WORD AreaID, POINT AreaPos, SIZE AreaSize, CBrokenWinCore* pBrokenWin)
: CBrkWinArea(AreaID,AreaPos,AreaSize,pBrokenWin)
{
	m_pPath = NULL;
}

// 
CBWRUArea::~CBWRUArea(void)
{
}

//  
void CBWRUArea::InitEvent()
{
	//   
	Rect AreaRect(-m_Size.cx, 0, 2 * m_Size.cx, 2 * m_Size.cy);

	//   
	m_pPath = new GraphicsPath();
	m_pPath->AddArc(AreaRect, 270, 90);
	m_pPath->AddLine(m_Size.cx - 1, m_Size.cy - 1, 0, m_Size.cy - 1);
	m_pPath->CloseFigure();
}

//  
void CBWRUArea::DeInitEvent()
{
	//  
	if (m_pPath != NULL)
	{
		delete m_pPath;
		m_pPath = NULL;
	}
}

//  
void CBWRUArea::DrawEvent(HDC hDC)
{
	Graphics graph(hDC);

	//   
	CBWMainWnd* pMainWnd = (CBWMainWnd*)m_pBrokenWin;
	_ASSERT(pMainWnd != NULL);

	//     
	AREA_STATE AreaState = pMainWnd->GetAreaState();

	SolidBrush LeftPathBrush(Color(200, 200, 0));
	if (AreaState == RIGHT_UP)
		LeftPathBrush.SetColor(Color(255, 255, 0));
	graph.FillPath(&LeftPathBrush, m_pPath);
}

//    
void CBWRUArea::MouseInArea(POINT point)
{
	//   
	CBWMainWnd* pMainWnd = (CBWMainWnd*)m_pBrokenWin;
	_ASSERT(pMainWnd != NULL);

	pMainWnd->SetAreaState(RIGHT_UP);
	pMainWnd->ReDrawBW();
}

//    
void CBWRUArea::MouseOutArea()
{
	//   
	CBWMainWnd* pMainWnd = (CBWMainWnd*)m_pBrokenWin;
	_ASSERT(pMainWnd != NULL);

	pMainWnd->SetAreaState(NONE);
	pMainWnd->ReDrawBW();
}
