// -------------------------------------------------------------------------
//    
//
//  
// -------------------------------------------------------------------------
#pragma once

class CBrokenWinCore;

//   
typedef struct INTERSECT_DATAtag
{
	UINT BelowAreaIdx;			//   
	RECT BelowInterRect;			//     
	RECT SelfInterRect;			//     
} INTERSECT_DATA,*PINTERSECT_DATA;

class CBrkWinArea
{
	friend class CBrokenWinCore;

public:
	CBrkWinArea(WORD AreaID, POINT AreaPos, SIZE AreaSize, CBrokenWinCore* pBrokenWin);
	virtual ~CBrkWinArea(void);

// 
protected:
	virtual void InitEvent() {}
	virtual void DeInitEvent() {}
	virtual void DrawEvent(HDC hDC) {}
	virtual BOOL LButtonDownEvent(BOOL fDoubleClick, UINT nFlags, POINT point) {return FALSE;}
	virtual void MouseInArea(POINT point) {};
	virtual void MouseOutArea() {};
	virtual BOOL MouseMoveEvent(UINT nFlags, POINT point) {return FALSE;}
	virtual BOOL LButtonUpEvent(UINT nFlags, POINT point) {return FALSE;}
	virtual BOOL RButtonDownEvent(BOOL fDoubleClick, UINT nFlags, POINT point) { return FALSE; }
	virtual BOOL ContextMenuEvent(UINT xPos, UINT yPos) { return FALSE; }

// 
private:
	BOOL PreparationDC(HDC hDC);
	void ProccesIntersect();
	void CopyIntersContent(RECT SourceRect, HDC hDestDC, RECT DestRect);
public:
	WORD GetAreaID();
	void GetAreaRect(RECT* pAreaRect);
	BOOL PtInArea(POINT Pt);
	void Draw(HDC hDC, BOOL bUpdateAreaImage);

// 
protected:
	WORD m_AreaID;										//  
	CBrokenWinCore* m_pBrokenWin;					//    
	POINT m_Pos;										//   
	SIZE  m_Size;										//   
private:
	vector<INTERSECT_DATA> m_InersectData;		//   
	HDC m_hCompDC;										//   
	HBITMAP m_hBitMap;								//   
	HBITMAP m_hOldBitMap;
};
