// -------------------------------------------------------------------
//      
//
//  
// -------------------------------------------------------------------
#pragma once

#include "BrkWinArea.h"

//      
typedef CBrkWinArea* CREATE_AREA_FUNC(POINT AreaPos, SIZE AreaSize, CBrokenWinCore* pBrokenWin);

//        
typedef struct BWAREA_MAP_ENTRYtag
{
	WORD AreaID;
	CREATE_AREA_FUNC* pCreateAreaFunc;
} BWAREA_MAP_ENTRY, *PBWAREA_MAP_ENTRY;

//       
#define DECLARE_BWAREA_MAP() virtual PBWAREA_MAP_ENTRY GetCreateAreasMap();

//      
#define BEGIN_BWAREA_MAP(BWClassName) \
PBWAREA_MAP_ENTRY BWClassName::GetCreateAreasMap() \
{ \
	static BWAREA_MAP_ENTRY _BWAreaEntries[] = \
	{

//      
#define BWAREA(ID,CreateAreaFunc) ID,CreateAreaFunc,

//      
#define END_BWAREA_MAP() \
		0,NULL \
	}; \
	return _BWAreaEntries; \
}

class CBrokenWinCore
{
	friend class CBrkWinArea;

public:
	CBrokenWinCore(void);
	~CBrokenWinCore(void);

//  
private:
	int Create(HWND hBrkWin, LPCREATESTRUCT lpCS);
	void Destroy();
	void Draw(HDC hDC);
	void LButtonDown(BOOL fDoubleClick, UINT nFlags, POINT point);
	void LButtonUp(UINT nFlags, POINT point);
	void RButtonDown(BOOL fDoubleClick, UINT nFlags, POINT point);
	void MouseMove(UINT nFlags, POINT point);
	void MouseLeave();
	void ContextMenu(UINT xPos, UINT yPos);

// 
protected:
	virtual int CreateEvent(HWND hBrkWin, LPCREATESTRUCT lpCS) {return 0;}
	virtual void DestroyEvent() {}
	virtual void CloseEvent() {}
	virtual void DrawEvent(HDC hDC) {}
	virtual BOOL SetCursorEvent() {return FALSE;}
	virtual void ContextMenuEvent(UINT xPos,UINT yPos) {}
	virtual void CommandEvent(int id, HWND hwndCtl, UINT codeNotify) {}
	virtual void WindowPosChangedEvent(LPWINDOWPOS lpwpos) {}
	virtual void TimerEvent(UINT TimerID) {}
	virtual void AppMessage1Event(WPARAM wParam, LPARAM lParam) {}
	virtual void AppMessage2Event(WPARAM wParam, LPARAM lParam) {}
	virtual void AppMessage3Event(WPARAM wParam, LPARAM lParam) {}
	virtual void AppMessage4Event(WPARAM wParam, LPARAM lParam) {}
	virtual void LButtonDownEvent(BOOL fDoubleClick, UINT nFlags, POINT point) {}
	virtual void RButtonDownEvent(BOOL fDoubleClick, UINT nFlags, POINT point) {}
	virtual void MouseMoveEvent(UINT nFlags, POINT point) {}
	virtual void LButtonUpEvent(UINT nFlags, POINT point) {}
	virtual void EndSessionEvent() {}
	virtual void PowerBroadCastEvent(UINT PowerEvent) {}
	virtual void DeviceChangeEvent(WPARAM wParam, LPARAM lParam) {}

// 
private:
	ATOM BrkWinRegisterClass(HINSTANCE hInstance);
	static LRESULT CALLBACK BrkWinWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
	CBrkWinArea* CreateArea(WORD AreaID, POINT AreaPos, SIZE AreaSize);
	void AddArea(CBrkWinArea* pBrkWinArea);
	void ClearAreas();
	BOOL PreparationBGDC(HDC hDC, int BWcx, int BWcy);
	void DestroyBGDC();
	void DrawBGforArea(HDC hDC, POINT AreaPos, SIZE AreaSize);
	int GetAreaIdx(WORD AreaID);
protected:
	virtual PBWAREA_MAP_ENTRY GetCreateAreasMap() = 0;
	CBrkWinArea* GetArea(WORD AreaID);
public:
	BOOL Init(HINSTANCE hInstance, POINT BrkWinPos, COLORREF TransColor, double Scale, WORD BRKWIN_ID);
	POINT GetAreaPos(WORD AreaID);
	SIZE GetAreaSize(WORD AreaID);
	void ReDrawBW();
	void ReDrawArea(WORD AreaID);
	HWND GetWnd();
	void SetAreaCapture(WORD AreaID);
	WORD GetAreaCapture();
	void ReleaseAreaCapture(WORD AreaID);

// 
private:
	POINT m_CapturePt;							//   
	HDC m_hBGDC;									//   
	HBITMAP m_hBGBitMap;							//  
	HBITMAP m_hBGOldBitMap;
	int m_iMovePrevAreaIdx;						//       
	int m_CaptureAreaIdx;						//    
protected:
	HWND m_hWnd;									//   
	vector<CBrkWinArea*> m_BrkWinAreas;		//   
	COLORREF m_TransColor;						//  
};
